function [energy, res, proved] = max_product_sls_for_netstruct(net_struct, time, algo, debug)

%=== Set default parameters unless provided.
if nargin < 2
   time = 0.05; % Allowed time in seconds.
                % Don't give it less than 0.02 seconds since it sometimes 
                % already takes 0.01 seconds for initialization.
end

if nargin < 3
    algo = 1; % GLS+
%    algo = 2; % ILS
%    algo = -1; % Anytime Mini-Buckets, exact if given enough time.
               % but there's a segmentation fault hiding somewhere.
end

if nargin < 4
    debug = 0; % no debug output. debug=100 means all debug output,
               % values in between gradually increase the level of detail.
end

%=== Convert the network into my factor graph representation and run SLS.
fg = net_struct2FactorGraph(net_struct);
[energy, res, proved] = c_sls_maxproduct(length(fg.vars),length(fg.factors),fg.sizes, fg.factors, time, algo, debug);
res = res+1;